Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QIODevice

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.core.QIODevice

All Implemented Interfaces:
  QtJambiInterface

Direct Known Subclasses:
  QAbstractSocket, QBuffer, QFile, QLocalSocket, QNetworkReply, QProcess

    public abstract class QIODevice

extends QObject

The `QIODevice` class is the base interface class of all I/O devices in Qt. `QIODevice` provides both a common implementation and an abstract interface for devices that support reading and writing of blocks of data, such as `QFile`, `QBuffer` and `QTcpSocket`. `QIODevice` is abstract and can not be instantiated, but it is common to use the interface it defines to provide device-independent I/O features. For example, Qt's XML classes operate on a `QIODevice` pointer, allowing them to be used with various devices (such as files and buffers).

Before accessing the device, `open()` must be called to set the correct OpenMode (such as `ReadOnly` or `ReadWrite` ). You can then write to the device with `write()` or putChar(), and read by calling either `read()`, `readLine()`, or `readAll()`. Call `close()` when you are done with the device.

`QIODevice` distinguishes between two types of devices: random-access devices and sequential devices.

- Random-access devices support seeking to arbitrary positions using `seek()`. The current position in the file is available by calling `pos()`. `QFile` and `QBuffer` are examples of random-access devices.
- Sequential devices don't support seeking to arbitrary positions. The data must be read in one pass. The functions `pos()` and `size()` don't work for sequential devices. `QTcpSocket` and `QProcess` are examples of sequential devices.

You can use `isSequential()` to determine the type of device.

`QIODevice` emits `readyRead()` when new data is available for reading; for example, if new data has arrived on the network or if additional data is appended to a file that you are reading from. You can call `bytesAvailable()` to determine the number of bytes that currently available for reading. It's common to use `bytesAvailable()` together with the `readyRead()` signal when programming with asynchronous devices such as `QTcpSocket`, where fragments of data can arrive at arbitrary points in time. `QIODevice` emits the `bytesWritten()` signal every time a payload of data has been written to the device. Use `bytesToWrite()` to determine the current amount of data waiting to be written.

Certain subclasses of `QIODevice`, such as `QTcpSocket` and `QProcess`, are asynchronous. This means that I/O functions such as `write()` or `read()` always return immediately, while communication with the device itself may happen when control goes back to the event loop. `QIODevice` provides functions that allow you to force these operations to be performed immediately, while blocking the calling thread and without entering the event loop. This allows `QIODevice` subclasses to be used without an event loop, or in a separate thread:

- `waitForReadyRead()` - This function suspends operation in the calling thread until new data is available for reading.
- `waitForBytesWritten()` - This function suspends operation in the calling thread until one payload of data has been written to the device.
- waitFor....() - Subclasses of `QIODevice` implement blocking functions for device-specific operations. For example, `QProcess` has a function called waitForStarted() which suspends operation in the calling thread until the process has started.

Calling these functions from the main, GUI thread, may cause your user interface to freeze. Example:

            QProcess gzip = new QProcess();
            gzip.start("gzip", Arrays.asList("-c"));
            if (!gzip.waitForStarted())
                return false;

            gzip.write(new QByteArray("uncompressed data"));

            QByteArray compressed = new QByteArray();
            while (gzip.waitForReadyRead(5000))
                compressed.append(gzip.readAll());

By subclassing `QIODevice`, you can provide the same interface to your own I/O devices. Subclasses of `QIODevice` are only required to implement the protected `readData()` and `writeData()` functions. `QIODevice` uses these functions to implement all its convenience functions, such as getChar(), `readLine()` and `write()`. `QIODevice` also handles access control for you, so you can safely assume that the device is opened in write mode if `writeData()` is called.

Some subclasses, such as `QFile` and `QTcpSocket`, are implemented using a memory buffer for intermediate storing of data. This reduces the number of required device accessing calls, which are often very slow. Buffering makes functions like getChar() and putChar() fast, as they can operate on the memory buffer instead of directly on the device itself. Certain I/O operations, however, don't work well with a buffer. For example, if several users open the same device and read it character by character, they may end up reading the same data when they meant to read a separate chunk each. For this reason, `QIODevice` allows you to bypass any buffering by passing the Unbuffered flag to `open()`. When subclassing `QIODevice`, remember to bypass any buffer you may use when the device is open in Unbuffered mode.

See also:
  `QBuffer`, `QFile`, and `QTcpSocket`.

Nested Class Summary
`static class` | `QIODevice.OpenMode` This is a flags class for com.trolltech.qt.core.QIODevice.OpenModeFlag
`static class` | `QIODevice.OpenModeFlag` This enum is used with `open()` to describe the mode in which a device is opened.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal0` | `aboutToClose` This signal is emitted when the device is about to close.
`QSignalEmitter.Signal1` | `bytesWritten` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal0` | `readChannelFinished` This signal is emitted when the input (reading) stream is closed in this device.
`QSignalEmitter.Signal0` | `readyRead` This signal is emitted once every time new data is available for reading from the device.

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QIODevice()` Constructs a `QIODevice` object.
`QIODevice(QObject parent)` Constructs a `QIODevice` object with the given `parent`.

Method Summary
`boolean` | `atEnd()` Returns true if the current read and write position is at the end of the device (i.
`long` | `bytesAvailable()` Returns the number of bytes that are available for reading.
`long` | `bytesToWrite()` For buffered devices, this function returns the number of bytes waiting to be written.
`boolean` | `canReadLine()` Returns true if a complete line of data can be read from the device; otherwise returns false.
`void` | `close()` First emits `aboutToClose()` , then closes the device and sets its OpenMode to `NotOpen` .
`java.lang.String` | `errorString()` Returns a human-readable description of the last device error that occurred.
`int` | `getByte()` Gets a byte from the device.
`boolean` | `isOpen()` Returns true if the device is open; otherwise returns false.
`boolean` | `isReadable()` Returns true if data can be read from the device; otherwise returns false.
`boolean` | `isSequential()` Returns true if this device is sequential; otherwise returns false.
`boolean` | `isTextModeEnabled()` Returns true if the `Text` flag is enabled; otherwise returns false.
`boolean` | `isWritable()` Returns true if data can be written to the device; otherwise returns false.
`boolean` | `open(QIODevice.OpenMode mode)` Opens the device and sets its OpenMode to `mode`.
`boolean` | `open(QIODevice.OpenModeFlag[] mode)` Opens the device and sets its OpenMode to `mode`.
`QIODevice.OpenMode` | `openMode()` Returns the mode in which the device has been opened; i.
`int` | `peek(byte[] data)`
`QByteArray` | `peek(long maxlen)` Peeks at most `maxSize` bytes from the device, returning the data peeked as a `QByteArray`.
`long` | `pos()` For random-access devices, this function returns the position that data is written to or read from.
`boolean` | `putByte(byte c)` Writes the character `c` to the device.
`int` | `read(byte[] data)`
`QByteArray` | `read(long maxlen)` Reads at most `maxSize` bytes from the device, and returns the data read as a `QByteArray`.
`QByteArray` | `readAll()` Reads all available data from the device, and returns it as a `QByteArray`.
`protected abstract int` | `readData(byte[] data)` Reads up to `maxSize` bytes from the device into `data`, and returns the number of bytes read or -1 if an error occurred.
`QByteArray` | `readLine()` Reads a line from the device, but no more than `maxSize` characters, and returns the result as a `QByteArray`.
`int` | `readLine(byte[] data)`
`QByteArray` | `readLine(long maxlen)` Reads a line from the device, but no more than `maxSize` characters, and returns the result as a `QByteArray`.
`protected int` | `readLineData(byte[] data)` Reads up to `maxSize` characters into `data` and returns the number of characters read.
`boolean` | `reset()` Seeks to the start of input for random-access devices.
`boolean` | `seek(long pos)` For random-access devices, this function sets the current position to `pos`, returning true on success, or false if an error occurred.
`protected void` | `setErrorString(java.lang.String errorString)` Sets the human readable description of the last device error that occurred to `str`.
`protected void` | `setOpenMode(QIODevice.OpenMode openMode)` Sets the OpenMode of the device to `openMode`.
`protected void` | `setOpenMode(QIODevice.OpenModeFlag[] openMode)` Sets the OpenMode of the device to `openMode`.
`void` | `setTextModeEnabled(boolean enabled)` If `enabled` is true, this function sets the `Text` flag on the device; otherwise the `Text` flag is removed.
`long` | `size()` For open random-access devices, this function returns the size of the device.
`void` | `ungetByte(byte c)` Puts the character `c` back into the device, and decrements the current position unless the position is 0.
`boolean` | `waitForBytesWritten(int msecs)` For buffered devices, this function waits until a payload of buffered written data has been written to the device and the `bytesWritten()` signal has been emitted, or until `msecs` milliseconds have passed.
`boolean` | `waitForReadyRead(int msecs)` Blocks until data is available for reading and the `readyRead()` signal has been emitted, or until `msecs` milliseconds have passed.
`int` | `write(byte[] data)`
`long` | `write(QByteArray data)` Writes the content of `byteArray` to the device.
`protected abstract int` | `writeData(byte[] data)` Writes up to `maxSize` bytes from `data` to the device.

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### aboutToClose

    public final QSignalEmitter.Signal0 aboutToClose

  This signal is emitted when the device is about to close. Connect this signal if you have operations that need to be performed before the device closes (e.g., if you have data in a separate buffer that needs to be written to the device).

### bytesWritten

    public final QSignalEmitter.Signal1 bytesWritten

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Long(named: bytes)>:

  This signal is emitted every time a payload of data has been written to the device. The `bytes` argument is set to the number of bytes that were written in this payload.

  `bytesWritten()` is not emitted recursively; if you reenter the event loop or call `waitForBytesWritten()` inside a slot connected to the `bytesWritten()` signal, the signal will not be reemitted (although `waitForBytesWritten()` may still return true).

See also:
  `readyRead()` .

### readChannelFinished

    public final QSignalEmitter.Signal0 readChannelFinished

  This signal is emitted when the input (reading) stream is closed in this device. It is emitted as soon as the closing is detected, which means that there might still be data available for reading with `read()`.

See also:
  `atEnd()`, and `read()`.

### readyRead

    public final QSignalEmitter.Signal0 readyRead

  This signal is emitted once every time new data is available for reading from the device. It will only be emitted again once new data is available, such as when a new payload of network data has arrived on your network socket, or when a new block of data has been appended to your device.

  `readyRead()` is not emitted recursively; if you reenter the event loop or call `waitForReadyRead()` inside a slot connected to the `readyRead()` signal, the signal will not be reemitted (although `waitForReadyRead()` may still return true).

  Note for developers implementing classes derived from `QIODevice`: you should always emit `readyRead()` when new data has arrived (do not emit it only because there's data still to be read in your buffers). Do not emit `readyRead()` in other conditions.

See also:
  `bytesWritten()` .

Constructor Detail

### QIODevice

    public QIODevice()

  Constructs a `QIODevice` object.

### QIODevice

    public QIODevice(QObject parent)

  Constructs a `QIODevice` object with the given `parent`.

Method Detail

### errorString

    public final java.lang.String errorString()

  Returns a human-readable description of the last device error that occurred.

See also:
  `setErrorString()`.

### isOpen

    public final boolean isOpen()

  Returns true if the device is open; otherwise returns false. A device is open if it can be read from and/or written to. By default, this function returns false if `openMode()` returns `NotOpen`.

See also:
  `openMode()`, and OpenMode.

### isReadable

    public final boolean isReadable()

  Returns true if data can be read from the device; otherwise returns false. Use `bytesAvailable()` to determine how many bytes can be read.

  This is a convenience function which checks if the OpenMode of the device contains the `ReadOnly` flag.

See also:
  `openMode()`, and OpenMode.

### isTextModeEnabled

    public final boolean isTextModeEnabled()

  Returns true if the `Text` flag is enabled; otherwise returns false.

See also:
  `setTextModeEnabled()`.

### isWritable

    public final boolean isWritable()

  Returns true if data can be written to the device; otherwise returns false.

  This is a convenience function which checks if the OpenMode of the device contains the `WriteOnly` flag.

See also:
  `openMode()`, and OpenMode.

### openMode

    public final QIODevice.OpenMode openMode()

  Returns the mode in which the device has been opened; i. . `ReadOnly` or `WriteOnly` .

See also:
  `setOpenMode()`, and OpenMode.

### peek

    public final QByteArray peek(long maxlen)

  Peeks at most `maxSize` bytes from the device, returning the data peeked as a `QByteArray`.

  Example:

              public boolean isExeFile(QFile file)
              {
                  return file.peek(2).equals("MZ");
              }

  This function has no way of reporting errors; returning an empty QByteArray() can mean either that no data was currently available for peeking, or that an error occurred.

See also:
  `read()`.

### putByte

    public final boolean putByte(byte c)

  Writes the character `c` to the device. Returns true on success; otherwise returns false.

See also:
  `write()`, getChar(), and ungetChar().

### read

    public final QByteArray read(long maxlen)

  Reads at most `maxSize` bytes from the device, and returns the data read as a `QByteArray`.

  This function has no way of reporting errors; returning an empty QByteArray() can mean either that no data was currently available for reading, or that an error occurred.

### readAll

    public final QByteArray readAll()

  Reads all available data from the device, and returns it as a `QByteArray`.

  This function has no way of reporting errors; returning an empty QByteArray() can mean either that no data was currently available for reading, or that an error occurred.

### readLine

    public final QByteArray readLine()

  Reads a line from the device, but no more than `maxSize` characters, and returns the result as a `QByteArray`.

  This function has no way of reporting errors; returning an empty QByteArray() can mean either that no data was currently available for reading, or that an error occurred.

### readLine

    public final QByteArray readLine(long maxlen)

  Reads a line from the device, but no more than `maxSize` characters, and returns the result as a `QByteArray`.

  This function has no way of reporting errors; returning an empty QByteArray() can mean either that no data was currently available for reading, or that an error occurred.

### setErrorString

    protected final void setErrorString(java.lang.String errorString)

  Sets the human readable description of the last device error that occurred to `str`.

See also:
  `errorString()`.

### setOpenMode

    protected final void setOpenMode(QIODevice.OpenModeFlag[] openMode)

  Sets the OpenMode of the device to `openMode`. Call this function to set the open mode if the flags change after the device has been opened.

See also:
  `openMode()`, and OpenMode.

### setOpenMode

    protected final void setOpenMode(QIODevice.OpenMode openMode)

  Sets the OpenMode of the device to `openMode`. Call this function to set the open mode if the flags change after the device has been opened.

See also:
  `openMode()`, and OpenMode.

### setTextModeEnabled

    public final void setTextModeEnabled(boolean enabled)

  If `enabled` is true, this function sets the `Text` flag on the device; otherwise the `Text` flag is removed. This feature is useful for classes that provide custom end-of-line handling on a `QIODevice`.

See also:
  `isTextModeEnabled()`, `open()`, and `setOpenMode()`.

### ungetByte

    public final void ungetByte(byte c)

  Puts the character `c` back into the device, and decrements the current position unless the position is 0. This function is usually called to "undo" a getChar() operation, such as when writing a backtracking parser.

  If `c` was not previously read from the device, the behavior is undefined.

### write

    public final long write(QByteArray data)

  Writes the content of `byteArray` to the device. Returns the number of bytes that were actually written, or -1 if an error occurred.

See also:
  `read()`, and `writeData()`.

### atEnd

    public boolean atEnd()

  Returns true if the current read and write position is at the end of the device (i. . there is no more data available for reading on the device); otherwise returns false.

  For some devices, `atEnd()` can return true even though there is more data to read. This special case only applies to devices that generate data in direct response to you calling `read()` (e.g., `/dev` or `/proc` files on Unix and Mac OS X, or console input / `stdin` on all platforms).

See also:
  `bytesAvailable()`, `read()`, and `isSequential()`.

### bytesAvailable

    public long bytesAvailable()

  Returns the number of bytes that are available for reading. This function is commonly used with sequential devices to determine the number of bytes to allocate in a buffer before reading.

  Subclasses that reimplement this function must call the base implementation in order to include the size of QIODevices' buffer. Example:

              public long bytesAvailable()
              {
                  return buffer.size() + super.bytesAvailable();
              }

See also:
  `bytesToWrite()`, `readyRead()` , and `isSequential()`.

### bytesToWrite

    public long bytesToWrite()

  For buffered devices, this function returns the number of bytes waiting to be written. For devices with no buffer, this function returns 0.

See also:
  `bytesAvailable()`, `bytesWritten()` , and `isSequential()`.

### canReadLine

    public boolean canReadLine()

  Returns true if a complete line of data can be read from the device; otherwise returns false.

  Note that unbuffered devices, which have no way of determining what can be read, always return false.

  This function is often called in conjunction with the `readyRead()` signal.

  Subclasses that reimplement this function must call the base implementation in order to include the size of the `QIODevice`'s buffer. Example:

              public boolean canReadLine()
              {
                  return buffer.contains("\n") || super.canReadLine();
              }

See also:
  `readyRead()` , and `readLine()`.

### close

    public void close()

  First emits `aboutToClose()` , then closes the device and sets its OpenMode to `NotOpen` . The error string is also reset.

See also:
  `setOpenMode()`, and OpenMode.

### isSequential

    public boolean isSequential()

  Returns true if this device is sequential; otherwise returns false.

  Sequential devices, as opposed to a random-access devices, have no concept of a start, an end, a size, or a current position, and they do not support seeking. You can only read from the device when it reports that data is available. The most common example of a sequential device is a network socket. On Unix, special files such as /dev/zero and fifo pipes are sequential.

  Regular files, on the other hand, do support random access. They have both a size and a current position, and they also support seeking backwards and forwards in the data stream. Regular files are non-sequential.

See also:
  `bytesAvailable()`.

### open

    public final boolean open(QIODevice.OpenModeFlag[] mode)

  Opens the device and sets its OpenMode to `mode`. Returns true if successful; otherwise returns false. This function should be called from any reimplementations of `open()` or other functions that open the device.

See also:
  `openMode()`, and OpenMode.

### open

    public boolean open(QIODevice.OpenMode mode)

  Opens the device and sets its OpenMode to `mode`. Returns true if successful; otherwise returns false. This function should be called from any reimplementations of `open()` or other functions that open the device.

See also:
  `openMode()`, and OpenMode.

### pos

    public long pos()

  For random-access devices, this function returns the position that data is written to or read from. For sequential devices or closed devices, where there is no concept of a "current position", 0 is returned.

  The current read/write position of the device is maintained internally by `QIODevice`, so reimplementing this function is not necessary. When subclassing `QIODevice`, use `QIODevice::seek()` to notify `QIODevice` about changes in the device position.

See also:
  `isSequential()`, and `seek()`.

### readData

    protected abstract int readData(byte[] data)

  Reads up to `maxSize` bytes from the device into `data`, and returns the number of bytes read or -1 if an error occurred. If there are no bytes to be read, this function should return -1 if there can never be more bytes available (for example: socket closed, pipe closed, sub-process finished).

  This function is called by `QIODevice`. Reimplement this function when creating a subclass of `QIODevice`.

See also:
  `read()`, `readLine()`, and `writeData()`.

### readLineData

    protected int readLineData(byte[] data)

  Reads up to `maxSize` characters into `data` and returns the number of characters read.

  This function is called by `readLine()`, and provides its base implementation, using getChar(). Buffered devices can improve the performance of `readLine()` by reimplementing this function.

  `readLine()` appends a '\0' byte to `data`; `readLineData()` does not need to do this.

  If you reimplement this function, be careful to return the correct value: it should return the number of bytes read in this line, including the terminating newline, or 0 if there is no line to be read at this point. If an error occurs, it should return -1 if and only if no bytes were read. Reading past EOF is considered an error.

### reset

    public boolean reset()

  Seeks to the start of input for random-access devices. Returns true on success; otherwise returns false (for example, if the device is not open).

  Note that when using a `QTextStream` on a `QFile`, calling `reset()` on the `QFile` will not have the expected result because `QTextStream` buffers the file. Use the `QTextStream::seek()` function instead.

See also:
  `seek()`.

### seek

    public boolean seek(long pos)

  For random-access devices, this function sets the current position to `pos`, returning true on success, or false if an error occurred. For sequential devices, the default behavior is to do nothing and return false.

  When subclassing `QIODevice`, you must call `QIODevice::seek()` at the start of your function to ensure integrity with `QIODevice`'s built-in buffer. The base implementation always returns true.

See also:
  `pos()`, and `isSequential()`.

### size

    public long size()

  For open random-access devices, this function returns the size of the device. For open sequential devices, `bytesAvailable()` is returned.

  If the device is closed, the size returned will not reflect the actual size of the device.

See also:
  `isSequential()`, and `pos()`.

### waitForBytesWritten

    public boolean waitForBytesWritten(int msecs)

  For buffered devices, this function waits until a payload of buffered written data has been written to the device and the `bytesWritten()` signal has been emitted, or until `msecs` milliseconds have passed. If msecs is -1, this function will not time out. For unbuffered devices, it returns immediately.

  Returns true if a payload of data was written to the device; otherwise returns false (i.e. if the operation timed out, or if an error occurred).

  This function can operate without an event loop. It is useful when writing non-GUI applications and when performing I/O operations in a non-GUI thread.

  If called from within a slot connected to the `bytesWritten()` signal, `bytesWritten()` will not be reemitted.

  Reimplement this function to provide a blocking API for a custom device. The default implementation does nothing, and returns false.

  Warning: Calling this function from the main (GUI) thread might cause your user interface to freeze.

See also:
  `waitForReadyRead()`.

### waitForReadyRead

    public boolean waitForReadyRead(int msecs)

  Blocks until data is available for reading and the `readyRead()` signal has been emitted, or until `msecs` milliseconds have passed. If msecs is -1, this function will not time out.

  Returns true if data is available for reading; otherwise returns false (if the operation timed out or if an error occurred).

  This function can operate without an event loop. It is useful when writing non-GUI applications and when performing I/O operations in a non-GUI thread.

  If called from within a slot connected to the `readyRead()` signal, `readyRead()` will not be reemitted.

  Reimplement this function to provide a blocking API for a custom device. The default implementation does nothing, and returns false.

  Warning: Calling this function from the main (GUI) thread might cause your user interface to freeze.

See also:
  `waitForBytesWritten()`.

### writeData

    protected abstract int writeData(byte[] data)

  Writes up to `maxSize` bytes from `data` to the device. Returns the number of bytes written, or -1 if an error occurred.

  This function is called by `QIODevice`. Reimplement this function when creating a subclass of `QIODevice`.

See also:
  `read()`, and `write()`.

### getByte

    public final int getByte()

  Gets a byte from the device.

  Returns:
    -1 on failure, or the value of the byte on success

### peek

    public final int peek(byte[] data)

### read

    public final int read(byte[] data)

### readLine

    public final int readLine(byte[] data)

### write

    public final int write(byte[] data)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD